]> git.treefish.org Git - backmeupscotty.git/blob - backmeupscotty
ff0f07ffa66104a53932bc3d428a61f0bdf80ee0
[backmeupscotty.git] / backmeupscotty
1 #!/bin/bash
2
3 REMOTE_HOST=localhost
4 REMOTE_DIR=/tmp/backmeupscotty/test
5 ARCHIVE_KEEPNBACKUPS=30
6 ARCHIVE_KEEPNDAYS=30
7 BACKUP_RUNEVERYNTHDAY=1
8
9 _ERROR_ENCOUNTERED=0
10
11 function timestamp {
12     date +'[%y-%m-%d|%H:%M:%S]'
13 }
14
15 function scottyline {
16     echo $(timestamp) $@
17 }
18
19 function scottyinfo {
20     if [ $_ERROR_ENCOUNTERED -eq 0 ]; then
21         scottyline $@
22     else
23         scottyline $@ >&2
24     fi
25 }
26
27 function scottyerror {
28     scottyline $@ >&2
29     if [ $_ERROR_ENCOUNTERED -eq 0 ]; then
30         _ERROR_ENCOUNTERED=1
31         scottyline "Going into verbose mode after error encounter." >&2
32     fi
33 }
34
35 function ssh255 {
36     ssh $@
37     sshret=$?
38
39     if [ $sshret -eq 255 ]; then
40         scottyerror "SSH connection failed!"
41         exit 1
42     else
43         return $sshret
44     fi
45 }
46
47 function grepbackups {
48     ssh255 $REMOTE_HOST "ls $REMOTE_DIR" | grep -E '[0-9]+-[0-9]+'
49 }
50
51 function isIncomplete {
52     if ( ssh255 $REMOTE_HOST '[ -d '$REMOTE_DIR/incomplete' ]' ); then
53         return 0
54     else
55         return 1
56     fi
57 }
58
59 function isNthDay {
60     if [ $(( ( $(date +%s) / (60*60*24) ) % $BACKUP_RUNEVERYNTHDAY )) -eq 0 ]; 
61     then
62         return 0
63     else
64         return 1
65     fi  
66 }
67
68 function latestTooOld {
69     for oldbackup in $(grepbackups); do
70         tstamp=$(echo $oldbackup | cut -d'-' -f1)
71         
72         if [ $(( $(date +%s) - $tstamp )) -lt \
73             $(( ($BACKUP_RUNEVERYNTHDAY*24+12)*60*60 )) ]
74         then
75             return 1
76         fi
77     done
78
79     return 0
80 }
81
82 function scottysync {
83     timestamp=$(date +%s)
84
85     scottyinfo "Syncing $SYNC_SRC to $REMOTE_HOST:$REMOTE_DIR @$timestamp."
86
87     if [ ! -d "$SYNC_SRC" ]; then
88         scottyerror "Source dir $SYNC_SRC does not exist. Not syncing!"
89         return 1
90     fi
91
92     if [ $(ls -A "$SYNC_SRC" | wc -l) -eq 0 ]; then
93         scottyerror "Source dir $SYNC_SRC is empty. Not syncing!"
94         return 1
95     fi
96
97     dir_current=$REMOTE_DIR/current
98     dir_incomplete=$REMOTE_DIR/incomplete
99     dir_timestamped=$REMOTE_DIR/$timestamp-$(date -d @$timestamp +%Y%m%d%H%M%S)
100
101     if [ -z $SYNC_EXC ]; then
102         rsync_exclude=""
103     else
104         rsync_exclude=$(eval echo --exclude={$SYNC_EXC} | tr -d {})
105     fi
106
107     if (ssh255 $REMOTE_HOST '[ ! -d '$REMOTE_DIR' ]'); then
108         scottyinfo "Creating destination directory $REMOTE_HOST:$REMOTE_DIR."
109         ssh255 $REMOTE_HOST "mkdir $REMOTE_DIR"
110     fi
111
112     if isIncomplete; then
113         scottyerror "Continuing old incomplete backup."
114     fi
115
116     scottyinfo "Starting rsync."
117     rsync -e ssh \
118         -v -aHAX --numeric-ids --delete --delete-excluded \
119         --link-dest=$dir_current \
120         $rsync_exclude \
121         $SYNC_SRC/ $REMOTE_HOST:$dir_incomplete/
122     
123     if [ $? -eq 0 ]; then
124         scottyinfo "Timestamping completed backup and linking to current backup."
125         ssh255 $REMOTE_HOST \
126             "mv $dir_incomplete $dir_timestamped && rm -f $dir_current && ln -s $(basename $dir_timestamped) $dir_current"
127     else
128         scottyerror "Rsync failed."
129     fi
130
131     while [ $(grepbackups | wc -l) -gt $ARCHIVE_KEEPNBACKUPS ]; do
132         oldestbackup=$(grepbackups | head -1)
133         oldestbackuptstamp=$(echo $oldestbackup | cut -d'-' -f1)
134
135         if [ $oldestbackuptstamp -lt $(( $(date +%s) - $ARCHIVE_KEEPNDAYS*60*60*24 )) ]; then
136             scottyinfo "Removing old backup $oldestbackup."
137             ssh255 $REMOTE_HOST rm -r "$REMOTE_DIR/$oldestbackup"
138         else
139             break
140         fi
141     done
142 }
143
144 function deleteLock {
145     if ! rmdir /var/lock/$(basename $0); then
146         scottyerror "Could not delete lockfile /tmp/$(basename $0).lock!"
147     fi
148 }
149
150 function cleanup_abort {
151     scottyerror "Caught exit signal! Cleaning up."
152
153     cleanup ABORT
154
155     if [ $(jobs -p) ]; then
156         scottyerror "TERMinating remaining child processes."
157         kill $(jobs -p)
158     fi
159
160     deleteLock
161
162     exit
163 }
164
165 function cleanup {
166     scottyinfo "No cleanup function was defined."
167 }
168
169 function prepare {
170     scottyinfo "No prepare function was defined."
171 }
172
173 function cleanup_normal {
174     cleanup
175     deleteLock
176 }
177
178 function printhelp {
179     cat <<EOF
180 Usage: $(basename $0) [OPTION]...
181
182 Recognized options:
183   -q   Only output errors
184   -n   Run only on nth day
185   -h   Print out this help
186 EOF
187 }
188
189 function backmeupscotty {
190     while getopts "qn:h" opt; do
191         case $opt in
192             q)
193                 exec > /dev/null
194                 ;;
195             n)
196                 BACKUP_RUNEVERYNTHDAY=$OPTARG
197                 ;;
198             h)
199                 printhelp
200                 exit 0
201                 ;;
202         esac
203     done
204     
205     ssh255 $REMOTE_HOST exit
206
207     if latestTooOld; then
208         scottyerror "The latest backup is too old."
209     elif isNthDay; then
210         scottyinfo "This is the nth day."
211     else
212         scottyinfo "No backup has to be done. Exiting."
213         exit 0
214     fi
215
216     scottyinfo "Performing backup."
217
218     trap cleanup_abort EXIT
219
220     prepare
221     scottysync
222
223     trap cleanup_normal EXIT
224
225     exit 0
226 }
227
228 if ! mkdir /var/lock/$(basename $0); then
229     scottyerror "Another instance of $(basename $0) is still running!"
230     exit 1
231 else
232     trap deleteLock EXIT
233 fi